VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   900
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   3285
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   900
   ScaleWidth      =   3285
   Begin VB.CommandButton Command1 
      Caption         =   "&Choose graph and plot type..."
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3015
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()

    ' Create an S-PLUS application object
    Dim pApp As Object
    Set pApp = CreateObject(GetLastAppStartedValue("ApplicationName") + ".Application")
    
    ' Now that we have an S-PLUS application object, we can create a graph sheet in S-PLUS
    Dim pGS As Object
    Set pGS = pApp.CreateObject("GraphSheet")
    
    ' Set up two variants to be used as the default selections in the lists in the graph
    ' gallery dialog you get from calling ChooseGraphAndPlotType() on a graph sheet object
    Dim v1 As Variant, v2 As Variant
    v1 = CVar("3D")
    v2 = CVar("3D Line Plot")
    
    ' Upon return, ChooseGraphAndPlotType() will modify v1 and v2 with the actual selections
    ' made in the dialog.  The hWnd parameter is your Visual Basic project's form window handle
    ' and is used to make the graph gallery dialog in S-PLUS appear to be owned by this project.
    bSuccess = pGS.ChooseGraphAndPlotType(v1, v2, hWnd)
    
    ' ChooseGraphAndPlotType() returns true if the user clicks the OK button.  If so, we
    ' print out the modified values of v1 and v2 which are the actual selections made in the
    ' graph gallery dialog.
    If (bSuccess = True) Then
        MsgBox "Graph type: " + CStr(v1) + " and plot type: " + CStr(v2) + " were chosen."
    End If

End Sub


