VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "CreatePlots method example"
   ClientHeight    =   6030
   ClientLeft      =   1665
   ClientTop       =   1515
   ClientWidth     =   5790
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   6030
   ScaleWidth      =   5790
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton Command3 
      Caption         =   "&3. Conditioned plot using CreateConditionedPlotsSeparateData()"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   5400
      Width           =   5535
   End
   Begin VB.CommandButton Command2 
      Caption         =   "&2. Conditioned plot using CreateConditionedPlots()"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   4800
      Width           =   5535
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&1. Plot using CreatePlots()"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   4200
      Width           =   5535
   End
   Begin VB.OLE OLE1 
      Height          =   3975
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   5535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()

    ' Create an embedded graph sheet and associate it with the Visual Basic
    ' OLE object "OLE1"
    OLE1.CreateEmbed "", GetLastAppStartedValue("EmbeddedGSTypeName")

    ' Get the actual graph sheet object that can be automated from the "OLE1"
    ' Visual Basic object by using the "object" property
    Dim pGS As Object
    Set pGS = OLE1.object
    
    ' Prepare some data to send to the graph sheet to draw a plot.
    ' NOTE: We have two columns of data here 100 rows long.
    Dim pDataArray(1 To 100, 1 To 2) As Double
    For i = 1 To 100
        pDataArray(i, 1) = i
        pDataArray(i, 2) = Sin(i)
    Next i
    
    ' Prepare an array of axis labels to use in the graph that will be drawn.
    ' NOTE: S-PLUS/Axum plots use the labels of columns specified for data as the
    ' axis labels by default.  Since we created two columns of data above, we must
    ' have two entries, one for each column of data.
    Dim pColumnNameArray(1 To 2) As String
    pColumnNameArray(1) = "x data"
    pColumnNameArray(2) = "Sin(x) data"
    
    ' Call the automation method CreatePlots() on the graph sheet object obtained
    ' above, passing the data created and the names of the data columns (there are
    ' two columns 100 rows long), and use the strings "2D" and "Line Plot" to create
    ' a two-dimensional line plot in the embedded graph sheet.
    bSuccess = pGS.CreatePlots("2D", "Line Plot", pDataArray, pColumnNameArray)
    
End Sub


Private Sub Command2_Click()

    ' Create an embedded graph sheet and associate it with the Visual Basic
    ' OLE object "OLE1"
    OLE1.CreateEmbed "", GetLastAppStartedValue("EmbeddedGSTypeName")

    ' Get the actual graph sheet object that can be automated from the "OLE1"
    ' Visual Basic object by using the "object" property
    Dim pGS As Object
    Set pGS = OLE1.object
    
    ' Prepare some data to send to the graph sheet to draw a plot.
    ' NOTE: We have three columns of data here 100 rows long.  The last column
    ' will be used as a conditioning column.
    Dim pDataArray(1 To 100, 1 To 3) As Double
    For i = 1 To 100
        pDataArray(i, 1) = i
        pDataArray(i, 2) = Sin(i)
        
        pDataArray(i, 3) = 1
        If (i > 25) Then
            pDataArray(i, 3) = 2
        End If
        If (i > 50) Then
            pDataArray(i, 3) = 3
        End If
        If (i > 75) Then
            pDataArray(i, 3) = 4
        End If
    Next i
    
    ' Prepare an array of axis labels to use in the graph that will be drawn.
    ' NOTE: S-PLUS/Axum plots use the labels of columns specified for data as the
    ' axis labels by default.  Since we created three columns of data above, we must
    ' have three entries, one for each column of data.
    Dim pColumnNameArray(1 To 3) As String
    pColumnNameArray(1) = "x data"
    pColumnNameArray(2) = "Sin(x) data"
    pColumnNameArray(3) = "ConditioningData"
    
    ' Call the automation method CreateConditionedPlots() on the graph sheet object obtained
    ' above, passing the data created and the names of the data columns (there are
    ' three columns 100 rows long and the last column will be automatically intrepreted as
    ' the conditioning data), and use the strings "2D" and "Line Plot" to create
    ' a two-dimensional line plot in the embedded graph sheet conditioned on the data in
    ' the last of the three columns of data we passed in.
    bSuccess = pGS.CreateConditionedPlots("2D", "Line Plot", 1, pDataArray, pColumnNameArray)

End Sub


Private Sub Command3_Click()

    ' Create an embedded graph sheet and associate it with the Visual Basic
    ' OLE object "OLE1"
    OLE1.CreateEmbed "", GetLastAppStartedValue("EmbeddedGSTypeName")

    ' Get the actual graph sheet object that can be automated from the "OLE1"
    ' Visual Basic object by using the "object" property
    Dim pGS As Object
    Set pGS = OLE1.object
    
    ' Prepare some data to send to the graph sheet to draw a plot.
    ' NOTE: We have two columns of data here 100 rows long.
    Dim pDataArray(1 To 100, 1 To 2) As Double
    For i = 1 To 100
        pDataArray(i, 1) = i
        pDataArray(i, 2) = Sin(i)
    Next i
    
    ' Prepare some data to send to the graph sheet to use for conditioning the plot.
    ' NOTE: We have one column of data here 100 rows long.
    Dim pConditionDataArray(1 To 100, 1 To 1) As Double
    For i = 1 To 100
        pConditionDataArray(i, 1) = 1
        If (i > 25) Then
            pConditionDataArray(i, 1) = 2
        End If
        If (i > 50) Then
            pConditionDataArray(i, 1) = 3
        End If
        If (i > 75) Then
            pConditionDataArray(i, 1) = 4
        End If
    Next i
    
    ' Prepare an array of axis labels to use in the graph that will be drawn.
    ' NOTE: S-PLUS/Axum plots use the labels of columns specified for data as the
    ' axis labels by default.  Since we created two columns of data above, we must
    ' have two entries, one for each column of data.
    Dim pDataColumnNameArray(1 To 2) As String
    pDataColumnNameArray(1) = "xData"
    pDataColumnNameArray(2) = "SinData"
    
    ' Now prepare another axis label to use in the graph for the conditioning column.
    ' NOTE: S-PLUS/Axum plots use the labels of columns specified for data as the
    ' axis labels by default.  Since we created one column of conditioning data above,
    ' we must have one entry in this array of names.
    Dim pConditionDataColumnNameArray(1 To 1) As String
    pConditionDataColumnNameArray(1) = "ConditioningData"
    
    ' Finally call CreateConditionedPlotsSeparateData() and specify the array of data
    ' to plot, the array of data to condition on, the array of data to plot column names to
    ' use for axis labels, and the array of column names for the conditioning data.  We also
    ' specify "2D" and "Line Plot" to create a conditioned two-dimensional line plot.
    bSuccess = pGS.CreateConditionedPlotsSeparateData( _
        "2D", _
        "Line Plot", _
        pDataArray, _
        pConditionDataArray, _
        pDataColumnNameArray, _
        pConditionDataColumnNameArray)

End Sub


