VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Test Mixed Data Type Column Xfer"
   ClientHeight    =   1875
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   4245
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1875
   ScaleWidth      =   4245
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton Command2 
      Caption         =   "Retrieve mixed column data from data.frame"
      Height          =   735
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   3975
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Create data.frame and fill with mixed columns"
      Height          =   735
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()

    ' Create an S-PLUS application object
    ' NOTE: We are using a static object variabler for the application
    ' object so that it won't automatically be released when this subroutine
    ' ends.  This is to keep the data.frame object we create here alive
    ' between subroutines.
    Static pApp As Object
    Set pApp = CreateObject(GetLastAppStartedValue("ApplicationName") + ".Application")
    
    ' Create a data.frame object
    ' NOTE: We are using a static object variable here which permits the
    ' object to remain active in S-PLUS/Axum until this entire Visual Basic
    ' program ends or this code is called again.
    Static pDF As Object
    Set pDF = pApp.CreateObject("DataFrame")
    
    ' Set the name of the newly created data.frame to "TestDF".
    pDF.NewName = "TestDF"
    
    ' Create a small 3 column by 2 row array to set into the "TestDF" data.frame.
    Dim pData(0 To 1, 0 To 2) As Variant
    pData(0, 0) = CDate("February 12, 1969")
    pData(1, 0) = CDate("April 21, 1998")
    pData(0, 1) = 1
    pData(1, 1) = 2
    pData(0, 2) = 3
    pData(1, 2) = 4
    
    ' Set the array of data into the data.frame object in S-PLUS/Axum
    pDF.DataAsArray = pData
    
End Sub


Private Sub Command2_Click()

    ' Create an S-PLUS application object
    ' NOTE: We are using a static object variabler for the application
    ' object so that it won't automatically be released when this subroutine
    ' ends.  This is to keep the data.frame object we create here alive
    ' between subroutines.
    Static pApp As Object
    Set pApp = CreateObject(GetLastAppStartedValue("ApplicationName") + ".Application")
    
    ' Get the "TestDF" data.frame object we previously created in the subroutine
    ' Command1_Click().
    ' NOTE: We are using a static object variable here which permits the
    ' object to remain active in S-PLUS/Axum until this entire Visual Basic
    ' program ends or this code is called again.
    Static pDF As Object
    Set pDF = pApp.GetObject("DataFrame", "TestDF")
    
    ' Get the data from the data.frame object into an array in Visual Basic
    pData = pDF.DataAsArray

    ' Get the upper and lower bounding indexes of the array
    Dim upperBound1 As Integer, upperBound2 As Integer
    Dim lowerBound1 As Integer, lowerBound2 As Integer
    upperBound1 = UBound(pData, 1)
    upperBound2 = UBound(pData, 2)
    lowerBound1 = LBound(pData, 1)
    lowerBound2 = LBound(pData, 2)

    ' Loop through the rows and columns of the array from the data.frame object
    ' "TestDF" and form a string which represents this data.
    Dim sMsg As String
    sMsg = "Data from data.frame TestDF:" + vbCrLf + vbCrLf
    For i = lowerBound1 To upperBound1
        For j = lowerBound2 To upperBound2
            sMsg = sMsg + CStr(pData(i, j))
            If (j < upperBound2) Then
                sMsg = sMsg + ", "
            End If
        Next j
        sMsg = sMsg + vbCrLf
    Next i

    ' Display a dialog box with the data retrieved.
    MsgBox sMsg

End Sub


