VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Object Dialogs Example"
   ClientHeight    =   2025
   ClientLeft      =   1155
   ClientTop       =   1500
   ClientWidth     =   4635
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2025
   ScaleWidth      =   4635
   Begin VB.CommandButton Command3 
      Caption         =   "ShowDialogInParentModeless()"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1320
      Width           =   4335
   End
   Begin VB.CommandButton Command2 
      Caption         =   "ShowDialogInParent()"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   4335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "ShowDialog()"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()

    ' Create an S-PLUS application object
    Dim pApp As Object
    Set pApp = CreateObject(GetLastAppStartedValue("ApplicationName") + ".Application")
    
    ' If the application is not visible, then make it visible by setting
    ' the property "Visible" of the application object to TRUE
    If (pApp.Visible = "F") Then
        pApp.Visible = True
    End If
    
    ' Create a graph sheet object
    Dim pGraphSheet As Object
    Set pGraphSheet = pApp.CreateObject("GraphSheet")
    
    ' Show the graph sheet property dialog in S-PLUS.
    ' NOTE: You need to switch focus to S-PLUS in order to see this dialog
    ' and change its values.  Once you have closed this dialog in S-PLUS,
    ' this script will continue.  This is an example of how the method
    ' ShowDialog() is modal and displays an object's property dialog in S-PLUS,
    ' rather than in Visual Basic.
    Dim bSuccess As Boolean
    bSuccess = pGraphSheet.ShowDialog()
    
End Sub


Private Sub Command2_Click()

    ' Create an S-PLUS application object
    Dim pApp As Object
    Set pApp = CreateObject(GetLastAppStartedValue("ApplicationName") + ".Application")
    
    ' Now create a graph sheet object
    Dim pGraphSheet As Object
    Set pGraphSheet = pApp.CreateObject("GraphSheet")
    
    ' Use ShowDialogInParent() to display the graph sheet object dialog
    ' in Visual Basic.  This happens because we pass in the window handle
    ' (hwnd) of this Visual Basic project form to ShowDialogInParent().
    ' Like ShowDialog(), ShowDialogInParent() is modal and will not allow
    ' this script to continue until you dismiss the object dialog.
    Dim bSuccess As Boolean
    bSuccess = pGraphSheet.ShowDialogInParent(hwnd)

End Sub


Private Sub Command3_Click()

    ' Create an S-PLUS application object
    Dim pApp As Object
    Set pApp = CreateObject(GetLastAppStartedValue("ApplicationName") + ".Application")
    
    ' Create a graph sheet object
    Dim pGraphSheet As Object
    Set pGraphSheet = pApp.CreateObject("GraphSheet")
    
    ' Use the automation method ShowDialogInParentModeless() on the
    ' graph sheet object to display the object dialog in this Visual
    ' Basic project form.  Notice that we must use a loop below to
    ' process events while the dialog is open and check whether the
    ' active window first obtained before entering the loop is valid.
    ' This is because ShowDialogInParentModeless() displays the object
    ' dialog in a modeless state which allows the Visual Basic script
    ' to continue immediately after the dialog is displayed.
    Dim bSuccess As Boolean
    bSuccess = pGraphSheet.ShowDialogInParentModeless(hwnd)
    If (bSuccess) Then
        
        ' Get the currently active window (which will be the newly
        ' opened graph sheet object dialog)
        Dim hWndDialog As Long
        hWndDialog = GetActiveWindow()
        
        ' Loop and process events until the dialog for the graph
        ' sheet is dismissed.  The Windows API call IsWindow() returns
        ' TRUE if the window handle you pass it is a valid window.
        Do
            DoEvents
        Loop While (IsWindow(hWndDialog) <> 0)
    
    End If

End Sub


