VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form GSPagesForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "GraphSheet Pages Sample"
   ClientHeight    =   5820
   ClientLeft      =   1560
   ClientTop       =   1515
   ClientWidth     =   6030
   LinkTopic       =   "VBEmbed"
   MaxButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5820
   ScaleWidth      =   6030
   Begin VB.TextBox ObjectPathName 
      Height          =   285
      Left            =   1680
      TabIndex        =   3
      Text            =   "e:\spluswin\home\gs1.sgr"
      Top             =   4680
      Width           =   4215
   End
   Begin VB.CommandButton DeleteObject 
      Caption         =   "&Delete Object"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   5160
      Width           =   1455
   End
   Begin VB.CommandButton CreateObject 
      Caption         =   "&Embed File"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   4560
      Width           =   1455
   End
   Begin ComctlLib.TabStrip TabStrip1 
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   5775
      _ExtentX        =   10186
      _ExtentY        =   661
      _Version        =   327682
      BeginProperty Tabs {0713E432-850A-101B-AFC0-4210102A8DA7} 
         NumTabs         =   1
         BeginProperty Tab1 {0713F341-850A-101B-AFC0-4210102A8DA7} 
            Object.Tag             =   ""
            ImageVarType    =   2
         EndProperty
      EndProperty
   End
   Begin VB.OLE OLE1 
      Height          =   3915
      Left            =   120
      SizeMode        =   1  'Stretch
      TabIndex        =   0
      Top             =   420
      Width           =   5775
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   5880
      Y1              =   4440
      Y2              =   4440
   End
End
Attribute VB_Name = "GSPagesForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub CreateArrow_Click()
    Dim pGraphSheet As Object
    Set pGraphSheet = OLE1.object
    
    pGraphSheet.CurrentPage = "Page1"
End Sub

Private Sub CreateObject_Click()
    
    ' Get the file path name of the graph sheet file to embed from the edit control
    ' on the form
    Dim sObjectPathName As String
    sObjectPathName = ObjectPathName.Text
    
    ' If a valid file path name was specified, then embed the graph sheet
    If (Len(sObjectPathName) > 0) Then
    
        ' Embed the graph sheet from a file into OLE1
        OLE1.CreateEmbed sObjectPathName, GetLastAppStartedValue("EmbeddedGSTypeName")

        ' Get the actual embedded graph sheet object from the OLE1 Visual Basic object.
        Dim pGS As Object
        Set pGS = OLE1.object
        
        ' Using the "Containees" method of graph sheet objects, get an array of
        ' graph sheet page objects contained by the embedded graph sheet.
        Dim pPages As Variant
        pPages = pGS.Containees("GraphSheetPage")
        
        ' For each page in the array, add the page name as a tab in the tab strip control.
        For i = LBound(pPages) To UBound(pPages)
            TabStrip1.Tabs.Add , , pPages(i).NewName
        Next i
        
        ' Select the first tab in the tab strip control to make the first page active
        ' in the embedded graph sheet.
        TabStrip1_Click
        
    End If
End Sub


Private Sub DeleteArrow_Click()
    Dim pGraphSheet As Object
    Set pGraphSheet = OLE1.object
    
    pGraphSheet.CurrentPage = "Page2"
End Sub

Private Sub DeleteObject_Click()
        
    ' Remove the embedded graph sheet object
    DeleteOLEObject

    ' Clear all the tabs from the tab strip control
    TabStrip1.Tabs.Clear
    
End Sub

Private Sub Form_Load()

    ' Clear all the tabs from the tab strip control
    TabStrip1.Tabs.Clear

End Sub


Private Sub ShowDialog_Click()
    Dim pArrow1 As Object
    If (GetChildObject(pArrow1, OLE1.object, "Arrow", "1")) Then
        bSuccess = pArrow1.ShowDialogInParent(GSPagesForm.hWnd)
    End If
End Sub


Private Sub TabStrip1_Click()
    On Error GoTo LErrReturn
    
    ' From the tab selected in the tab strip control, get the caption
    ' of the tab which is the name of the page in the embedded graph
    ' sheet object to make active.
    Dim aTab As Object
    Set aTab = TabStrip1.SelectedItem
    Dim sCaption As String
    sCaption = aTab.Caption
    
    ' Get the actual embedded graph sheet object from the OLE1 Visual
    ' Basic object.
    Dim pGS As Object
    Set pGS = OLE1.object
    
    ' Set the active page in the embedded graph sheet.
    pGS.CurrentPage = sCaption

LErrReturn:
End Sub


Private Sub Text1_Change()

End Sub


