VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form VBEmbed 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "VB Embedded Object Sample"
   ClientHeight    =   7110
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   6030
   LinkTopic       =   "VBEmbed"
   MaxButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   7110
   ScaleWidth      =   6030
   Begin VB.CommandButton ShowDialog 
      Caption         =   "Arrow Dialog..."
      Height          =   495
      Left            =   2280
      TabIndex        =   8
      Top             =   5160
      Width           =   1455
   End
   Begin VB.CommandButton SaveObject 
      Caption         =   "&Save Object..."
      Height          =   495
      Left            =   1680
      TabIndex        =   7
      Top             =   6480
      Width           =   1455
   End
   Begin VB.CommandButton OpenObject 
      Caption         =   "&Open Object..."
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   6480
      Width           =   1455
   End
   Begin VB.CommandButton DeleteArrow 
      Caption         =   "Delete Arrow"
      Height          =   495
      Left            =   3840
      TabIndex        =   5
      Top             =   5160
      Width           =   1455
   End
   Begin VB.CommandButton DeleteObject 
      Caption         =   "&Delete Object"
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   5760
      Width           =   1455
   End
   Begin VB.CommandButton CreateArrow 
      Caption         =   "Create Arrow"
      Height          =   495
      Left            =   720
      TabIndex        =   3
      Top             =   5160
      Width           =   1455
   End
   Begin VB.TextBox ObjectType 
      BackColor       =   &H00C0C0C0&
      Height          =   285
      Left            =   1800
      Locked          =   -1  'True
      TabIndex        =   2
      Text            =   "SPLUSGraphSheetFileType"
      Top             =   4680
      Width           =   4095
   End
   Begin VB.CommandButton CreateObject 
      Caption         =   "&Create Object"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   4560
      Width           =   1455
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   5400
      Top             =   6480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Line Line2 
      X1              =   120
      X2              =   5880
      Y1              =   6360
      Y2              =   6360
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   5880
      Y1              =   4440
      Y2              =   4440
   End
   Begin VB.Label ObjectPathName 
      BackStyle       =   0  'Transparent
      Height          =   375
      Left            =   120
      TabIndex        =   9
      Top             =   4080
      Width           =   5775
   End
   Begin VB.OLE OLE1 
      Height          =   3975
      Left            =   120
      SizeMode        =   1  'Stretch
      TabIndex        =   0
      Top             =   120
      Width           =   5775
   End
End
Attribute VB_Name = "VBEmbed"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub CreateArrow_Click()
    
    ' Get the actual embedded graph sheet object from OLE1
    Dim pGraphSheet As Object
    Set pGraphSheet = OLE1.object
    
    ' Create an arrow in this graph sheet object.
    ' NOTE: We use a static variable for this arrow so it will not
    ' be released until this entire Visual Basic program has ended
    ' or this code is re-executed.
    Static pArrowCreated As Object
    Set pArrowCreated = pGraphSheet.CreateObject("Arrow")
    
End Sub

Private Sub CreateObject_Click()
    
    ' Retrieve the object class name for the embedded object to create from the edit field on the form
    Dim sObjectClassToCreate As String
    sObjectClassToCreate = ObjectType.Text
    
    ' If valid class name, then create a new embedded object of this type in OLE1
    If (Len(sObjectClassToCreate) > 0) Then
        OLE1.CreateEmbed "", sObjectClassToCreate
    End If

    ' Reset the pathname control to indicate that this embedded object as not been saved to disk yet.
    UpdateObjectPathName ""
    
End Sub


Private Sub DeleteArrow_Click()
    
    ' Get the first arrow in the embedded graph sheet and remove it
    Dim pArrow1 As Object
    If (GetChildObject(pArrow1, OLE1.object, "Arrow", "1")) Then
        bSuccess = OLE1.object.RemoveObject(pArrow1)
    End If
    
End Sub

Private Sub DeleteObject_Click()
    ' Delete the embedded object
    DeleteOLEObject

    ' Reset the pathname control
    UpdateObjectPathName ""
End Sub

Private Sub Form_Load()

    ' Set the object class name of the embedded object to create in the edit field
    ObjectType.Text = GetLastAppStartedValue("EmbeddedGSTypeName")

End Sub

Private Sub OpenObject_Click()
    
    ' Use the common dialog control to display a file open dialog for files
    ' of type .OLE which will be used to save embedded objects from this Visual
    ' Basic program (see the SaveObject_Click() routine).
    CommonDialog1.DefaultExt = ".OLE"
    CommonDialog1.Filter = "OLE Objects (*.OLE)|*.OLE|All Files(*.*)|*.*"
    CommonDialog1.Flags = cdlOFNFileMustExist
    CommonDialog1.ShowOpen
    
    ' Get the file pathname to open from the dialog
    Dim sPathNameToOpen As String
    sPathNameToOpen = CommonDialog1.FileName
    
    ' Check for validity
    If (Len(Trim$(sPathNameToOpen)) <= 0) Then
        Exit Sub
    End If
    
    ' Delete any existing embedded object and read in the one selected from the file
    DeleteOLEObject
    Open sPathNameToOpen For Binary Access Read Lock Read As #1
        OLE1.ReadFromFile 1
    Close #1

    ' Update the pathname control to contain the newly opened .OLE file pathname
    UpdateObjectPathName sPathNameToOpen
    
End Sub

Private Sub SaveObject_Click()
    
    ' Use the common dialog control to display a file save as dialog for files
    ' of type .OLE which will be used to save embedded objects from this Visual
    ' Basic program.
    CommonDialog1.DefaultExt = ".OLE"
    CommonDialog1.Filter = "OLE Objects (*.OLE)|*.OLE|All Files(*.*)|*.*"
    CommonDialog1.Flags = cdlOFNPathMustExist Or cdlOFNOverwritePrompt
    CommonDialog1.ShowSave
    
    ' Get the file pathname to open from the dialog
    Dim sPathNameToSaveAs As String
    sPathNameToSaveAs = CommonDialog1.FileName
    
    ' Check for validity
    If (Len(Trim$(sPathNameToSaveAs)) <= 0) Then
        Exit Sub
    End If
    
    ' Save the embedded object to the file path name specified
    Open sPathNameToSaveAs For Binary Access Write As #1
        OLE1.SaveToFile 1
    Close #1

    ' Update the pathname control to contain the newly saved embedded object .OLE file pathname
    UpdateObjectPathName sPathNameToSaveAs
    
End Sub


Private Sub ShowDialog_Click()
    
    ' Get the first arrow in the embedded graph sheet and display the
    ' arrow object dialog in this project.
    Dim pArrow1 As Object
    If (GetChildObject(pArrow1, OLE1.object, "Arrow", "1")) Then
        bSuccess = pArrow1.ShowDialogInParent(VBEmbed.hWnd)
    End If
    
End Sub


